// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from off_highway_general_purpose_radar_msgs:msg/Information.idl
// generated code does not contain a copyright notice
#include "off_highway_general_purpose_radar_msgs/msg/detail/information__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"

bool
off_highway_general_purpose_radar_msgs__msg__Information__init(off_highway_general_purpose_radar_msgs__msg__Information * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    off_highway_general_purpose_radar_msgs__msg__Information__fini(msg);
    return false;
  }
  // sensor_type
  // hw_temperature
  // sensor_blind
  // sw_fail
  // hw_fail
  // can_fail
  // config_fail
  // diag_mode
  // dtc
  // dtc_order_id
  // sensor_not_safe
  return true;
}

void
off_highway_general_purpose_radar_msgs__msg__Information__fini(off_highway_general_purpose_radar_msgs__msg__Information * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // sensor_type
  // hw_temperature
  // sensor_blind
  // sw_fail
  // hw_fail
  // can_fail
  // config_fail
  // diag_mode
  // dtc
  // dtc_order_id
  // sensor_not_safe
}

bool
off_highway_general_purpose_radar_msgs__msg__Information__are_equal(const off_highway_general_purpose_radar_msgs__msg__Information * lhs, const off_highway_general_purpose_radar_msgs__msg__Information * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // sensor_type
  if (lhs->sensor_type != rhs->sensor_type) {
    return false;
  }
  // hw_temperature
  if (lhs->hw_temperature != rhs->hw_temperature) {
    return false;
  }
  // sensor_blind
  if (lhs->sensor_blind != rhs->sensor_blind) {
    return false;
  }
  // sw_fail
  if (lhs->sw_fail != rhs->sw_fail) {
    return false;
  }
  // hw_fail
  if (lhs->hw_fail != rhs->hw_fail) {
    return false;
  }
  // can_fail
  if (lhs->can_fail != rhs->can_fail) {
    return false;
  }
  // config_fail
  if (lhs->config_fail != rhs->config_fail) {
    return false;
  }
  // diag_mode
  if (lhs->diag_mode != rhs->diag_mode) {
    return false;
  }
  // dtc
  if (lhs->dtc != rhs->dtc) {
    return false;
  }
  // dtc_order_id
  if (lhs->dtc_order_id != rhs->dtc_order_id) {
    return false;
  }
  // sensor_not_safe
  if (lhs->sensor_not_safe != rhs->sensor_not_safe) {
    return false;
  }
  return true;
}

bool
off_highway_general_purpose_radar_msgs__msg__Information__copy(
  const off_highway_general_purpose_radar_msgs__msg__Information * input,
  off_highway_general_purpose_radar_msgs__msg__Information * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // sensor_type
  output->sensor_type = input->sensor_type;
  // hw_temperature
  output->hw_temperature = input->hw_temperature;
  // sensor_blind
  output->sensor_blind = input->sensor_blind;
  // sw_fail
  output->sw_fail = input->sw_fail;
  // hw_fail
  output->hw_fail = input->hw_fail;
  // can_fail
  output->can_fail = input->can_fail;
  // config_fail
  output->config_fail = input->config_fail;
  // diag_mode
  output->diag_mode = input->diag_mode;
  // dtc
  output->dtc = input->dtc;
  // dtc_order_id
  output->dtc_order_id = input->dtc_order_id;
  // sensor_not_safe
  output->sensor_not_safe = input->sensor_not_safe;
  return true;
}

off_highway_general_purpose_radar_msgs__msg__Information *
off_highway_general_purpose_radar_msgs__msg__Information__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_general_purpose_radar_msgs__msg__Information * msg = (off_highway_general_purpose_radar_msgs__msg__Information *)allocator.allocate(sizeof(off_highway_general_purpose_radar_msgs__msg__Information), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(off_highway_general_purpose_radar_msgs__msg__Information));
  bool success = off_highway_general_purpose_radar_msgs__msg__Information__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
off_highway_general_purpose_radar_msgs__msg__Information__destroy(off_highway_general_purpose_radar_msgs__msg__Information * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    off_highway_general_purpose_radar_msgs__msg__Information__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
off_highway_general_purpose_radar_msgs__msg__Information__Sequence__init(off_highway_general_purpose_radar_msgs__msg__Information__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_general_purpose_radar_msgs__msg__Information * data = NULL;

  if (size) {
    data = (off_highway_general_purpose_radar_msgs__msg__Information *)allocator.zero_allocate(size, sizeof(off_highway_general_purpose_radar_msgs__msg__Information), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = off_highway_general_purpose_radar_msgs__msg__Information__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        off_highway_general_purpose_radar_msgs__msg__Information__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
off_highway_general_purpose_radar_msgs__msg__Information__Sequence__fini(off_highway_general_purpose_radar_msgs__msg__Information__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      off_highway_general_purpose_radar_msgs__msg__Information__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

off_highway_general_purpose_radar_msgs__msg__Information__Sequence *
off_highway_general_purpose_radar_msgs__msg__Information__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  off_highway_general_purpose_radar_msgs__msg__Information__Sequence * array = (off_highway_general_purpose_radar_msgs__msg__Information__Sequence *)allocator.allocate(sizeof(off_highway_general_purpose_radar_msgs__msg__Information__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = off_highway_general_purpose_radar_msgs__msg__Information__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
off_highway_general_purpose_radar_msgs__msg__Information__Sequence__destroy(off_highway_general_purpose_radar_msgs__msg__Information__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    off_highway_general_purpose_radar_msgs__msg__Information__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
off_highway_general_purpose_radar_msgs__msg__Information__Sequence__are_equal(const off_highway_general_purpose_radar_msgs__msg__Information__Sequence * lhs, const off_highway_general_purpose_radar_msgs__msg__Information__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!off_highway_general_purpose_radar_msgs__msg__Information__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
off_highway_general_purpose_radar_msgs__msg__Information__Sequence__copy(
  const off_highway_general_purpose_radar_msgs__msg__Information__Sequence * input,
  off_highway_general_purpose_radar_msgs__msg__Information__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(off_highway_general_purpose_radar_msgs__msg__Information);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    off_highway_general_purpose_radar_msgs__msg__Information * data =
      (off_highway_general_purpose_radar_msgs__msg__Information *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!off_highway_general_purpose_radar_msgs__msg__Information__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          off_highway_general_purpose_radar_msgs__msg__Information__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!off_highway_general_purpose_radar_msgs__msg__Information__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
